/* 複素数の演算 */
#include <stdio.h>

typedef struct {
  double re;
  double im;
} Complex;

Complex cadd(Complex,Complex); 
Complex csub(Complex,Complex);
Complex cmul(Complex,Complex);
Complex cdiv(Complex,Complex);

int main()
{
  Complex x,y,ans;

  x.re=1.0;
  x.im=2.0;
  y.re=4.0;
  y.im=8.0;

  ans=cadd(x,y);
  printf("(%f,%f)\n",ans.re,ans.im);
  ans=csub(x,y);
  printf("(%f,%f)\n",ans.re,ans.im);
  ans=cmul(x,y);
  printf("(%f,%f)\n",ans.re,ans.im);
  ans=cdiv(x,y);
  printf("(%f,%f)\n",ans.re,ans.im);
}

Complex cadd(Complex z, Complex w)
{
  Complex t;
  t.re=z.re+w.re;
  t.im=z.im+w.im;
  return(t);
}

Complex csub(Complex z, Complex w)
{
  Complex t;
  t.re=z.re-w.re;
  t.im=z.im-w.im;

  return(t);
}

Complex cmul(Complex z, Complex w)
{
  Complex t;
  t.re=z.re*w.re-z.im*w.im;
  t.im=z.re*w.im+z.im*w.re;

  return(t);
}

Complex cdiv(Complex z, Complex w)
{
  Complex t;
  double s;
  s=w.re*w.re+w.im*w.im;

  t.re=(z.re*w.re+z.im*w.im)/s;
  t.im=(z.im*w.re-z.re*w.im)/s;

  return(t);
}
