/* 二分法による方程式の解: f(a)>0 and f(b)<0 の場合 */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

/* 関数f(x)のプロトタイプ宣言。
   f(x)の返り値の型と引数の型をまず宣言する。 */
double f(double);

int main()
{
  double a=0.0, b=10.0;
  double err=b-a;    /* 計算誤差を格納する。 */
  double eps=0.0001; /* 許容する誤差を与える。 */

  double t;
  /* 計算誤差が許容する誤差を上回る間は二分法を続ける。*/
  while( err > eps ){
    t=(b+a)/2;
    if( f(t)*f(a) < 0.0 ){
      b=t;
    }else{
      a=t;
    }
    err=b-a;
    printf("err:%lf, %lf < c < %lf\n", err,a,b);
  }
}
double f(double x)
{
  return(2.0-x*x);
}
