/* 二分法による方程式の解 */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

/* 二分法を実行する関数 */
double bisec(double,double,double);

/* f(x) */
double f(double);

int main()
{
  double a=0.0, b=10.0;
  double eps=0.0001;
  printf("%lf\n", bisec(a,b,eps));
}

/* 二分法を実行する関数 */
double bisec(double a, double b, double eps)
{
  double err=b-a;
  double t;
  while( err > eps ){
    t=(b+a)/2;
    if( f(t)*f(a) < 0.0 ){
      b=t;
    }else{
      a=t;
    }
    err=b-a;
  }
  t=(b+a)/2;
  return(t);
}

double f(double x)
{
  return(2.0-x*x);
}
