/* 方程式 x^4 - 8x^2 +5 = 0 の解を二分法で求める */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

double bisec(double,double,double);
double f(double);

int main()
{
  double start=-5.0;
  double h=0.5;
  double a, b;
  double eps=0.0001;
  /*
    a の値を -5.0 から 5.0 まで 0.5 刻みで増加させながら、
    b の値は a+0.5 と設定する。f(a)とf(b)の符号が異なる時に
    aとbの間にf(x)=0の解があるから、二分法で解を求める。
   */
  for(a=start; a<5.0; a+=h){
    b=a+h;
    if( f(a)*f(b)<0.0 ){
      printf("%lf\n", bisec(a,b,eps));
    }
  }
}

double bisec(double a, double b, double eps)
{
  double err=b-a;
  double t;
  while( err > eps ){
    t=(b+a)/2;
    if( f(t)*f(a) < 0.0 ){
      b=t;
    }else{
      a=t;
    }
    err=b-a;
  }
  t=(b+a)/2;
  return(t);
}

double f(double x)
{
  return(x*x*x*x-8*x*x+5);
}
