/* ニュートン補完の結果を確認する処理 */
#include <stdio.h>

#define N 5
double x[N]={-1.0,1.3,1.8,2.1,2.3};
double y[N]={-2.0,2.6,3.6,4.2,6.0};

double A[N][N];

double f(double, int, double *, double *);

int main()
{
  int i,j,k;
  double z;

  for(i=0; i<N; ++i){
    for(j=0; j<N; ++j){
      A[i][j]=0;
    }
  }

  for(i=0; i<N; ++i){
    A[i][0]=y[i];
  }

  for(j=1; j<N; ++j){
    for(i=0; i<N-j; ++i){
      A[i][j]=(A[i+1][j-1]-A[i][j-1])/(x[i+j]-x[i]);
    }
  }

  for(i=0; i<N; ++i){
    for(j=0; j<N; ++j){
      printf("%f ",A[i][j]);
    }
    printf("\n");
  }
  
  for(z=0; z<10; z+=0.1){
    printf( "%f %f\n", z,f(z, N, x, y));
  }

  /* 各x[k],y[k]について、f(x[k])=y[k] を確認する */
  for(k=0; k<N; ++k){
    printf("%lf\n",y[k]-f(x[k],N,x,y));
  }
}

double f(double x0, int n, double xn[], double yn[])
{
  int i,j,k,l;
  double s=0,t=1, u=1, v=0;

  s=yn[0];
  for(k=1; k<n; ++k){
    t=1;
    for(l=0; l<k; ++l){
      t*=(x0-xn[l]);
    }
    t*=A[0][k];
    s+=t;
  }
  return(s);
}
  
