/* 台形則の処理を関数とする */
#include <stdio.h>
#include <math.h>

/* 台形則の処理を実行する関数 */
double daikei(double,double,double);
double f(double);
int main()
{
  double a=0, b=1;
  double eps=1.0e-7;
  printf("%.10lf\n",daikei(a,b,eps));
}

/* 台形則の処理を実行する関数 */
double daikei(double a,double b,double eps)
{
  int n=1;
  int k;
  double h=(b-a)/n;
  double s0=(f(a)+f(b))*h/2;
  double s;
  double err=1.0;
  while( err > eps ){
    n=n*2;
    h=h/2;
    s=s0/2;
    for( k=1; k < n; k+=2 ){
      s+=f(a+k*h)*h;
    }
    err=fabs(s-s0);
    s0=s;
  }
  return(s);
}
double f(double x)
{
  return(x*x);
}
