/* シンプソン法の処理を関数とする */
#include <stdio.h>
#include <math.h>

/* シンプソン法の処理を実行する関数 */
double simpson(double,double,double);
double f(double);

int main()
{
  double a=0.0, b=1;
  double eps=1.0e-7;
  printf("%.10lf\n",simpson(a,b,eps));
}

double simpson(double a,double b,double eps){
  int k;
  int n=1;
  double h=(b-a)/n;
  double err=1.0;
  double se0=(f(a)+f(b))*h/6;
  double so0=4*f((a+b)/2)*h/6;
  double s,se,so;
  while(eps < err ){
    n*=2;
    h=h/2;
    se=se0/2+so0/4;
    so=0;
    for( k=0; k<n; ++k ){
      so += 4*f(a+k*h+h/2);
    }
    so *= h/6;
    err=fabs(so+se-so0-se0);
    se0=se;
    so0=so;
  }
  return(so0+se0);
}
double f(double x)
{
  return(exp(x));
}
