/* 修正オイラー法とルンゲクッタ法の誤差 */
#include <stdio.h>
#include <math.h>

double F(double);

int main()
{
  int i, n=100;
  double h=0.1;
  double k1,k2,k3,k4;
  double f,g,errf,errg;

  f=0.01;
  g=f;
  for( i=1; i < n; ++i ){
    /* f にルンゲクッタ法の数値解を格納 */
    k1=F(f);
    k2=F(f+k1*h/2);
    k3=F(f+k2*h/2);
    k4=F(f+k3*h);
    f=f+(k1+2*k2+2*k3+k4)*h/6;
    /* g に修正オイラー法の数値解を格納 */
    g=g+F(g+F(g)*h/2)*h;
    /* errf はルンゲクッタ法の誤差 */
    errf=fabs(f-1/(1+((1/0.01)-1)*exp(-h*i)));
    /* errg は修正オイラー法の誤差 */
    errg=fabs(g-1/(1+((1/0.01)-1)*exp(-h*i)));
    printf("%f %.10f %.10f\n", h*i, errf,errg);
  }
}
double F(double t)
{
  return( t*(1-t) );
}
