#include <stdio.h>
#include <math.h>

void rk(double,double,double,double,int,
        double *,double *,double);
double F(double,double,double);
double G(double,double,double,double);

#define N 3000

int main()
{
  int i, n=N;
  double h=0.01;
  double w=1.1;
  double k1,k2,k3,k4;
  double l1,l2,l3,l4;
  double x,f,g;
  double y1[N],y2[N];

  f=0.8;
  g=0.8;
  x=0.0;
  rk(x,f,g,h,n,y1,y2,w);
  for( i=0; i < n; ++i ){
    printf("%.10lf %.10lf\n", y1[i],y2[i]);
    x=x+h;
  }
}
double F(double x, double f,double g)
{
  return( g );
}
double G(double x, double f,double g,double w)
{
  return( -f+sin(w*x) );
}
void rk(double x0, double f0, double g0, double h,
   int T, double y1[],double y2[],double w)
{
  int i;
  double k1,k2,k3,k4,l1,l2,l3,l4;
  double x,f,g;
  x=x0;
  y1[0]=f0;
  y2[0]=g0;
  f=y1[0];
  g=y2[0];
  for( i=1; i < T; ++i ){
    k1=F(x,f,g);
    l1=G(x,f,g,w);
    k2=F(x+h/2,f+k1*h/2,g+l1*h/2);
    l2=G(x+h/2,f+k1*h/2,g+l1*h/2,w);
    k3=F(x+h/2,f+k2*h/2,g+l2*h/2);
    l3=G(x+h/2,f+k2*h/2,g+l2*h/2,w);
    k4=F(x+h,f+k3*h,g+l3*h);
    l4=G(x+h,f+k3*h,g+l3*h,w);
    f=f+(k1+2*k2+2*k3+k4)*h/6;
    g=g+(l1+2*l2+2*l3+l4)*h/6;
    x=x+h;
    y1[i]=f;
    y2[i]=g;
  }
}
