#include <stdio.h>
#include <math.h>
#define N 4
double a[N][N]={{1,2,3,1},{-1,-2,2,4},
	    {4,2,-3,5},{5,-4,-3,1}};
double b[N]={10, 10, 2, 6};

void print();

int main()
{
  int i,j,k;
  int p;
  double max,tmp;

  int n=N;  //変数の数、行列の次元

  //配列a,bを行列とベクトル風に表示
  print();

  //前進消去
  for(k=0; k < N; ++k){
    //ピボット選択
    p=k;
    max=fabs(a[k][k]);
    for(i=k+1; i < N; ++i){
      if( fabs(a[i][k]) > max ){
	p=i;
	max=fabs(a[i][k]);
      }
    }
    //行の交換
    if( p != k ){
      for( j=k; j<N; ++j){
	tmp=a[k][j];
	a[k][j]=a[p][j];
	a[p][j]=tmp;
      }
      tmp=b[k]; b[k]=b[p]; b[p]=tmp;
    }
    
    //第k行について第0列を規格化
    b[k]=b[k]/a[k][k];
    for(j=N-1; j >= k; --j){
      a[k][j]=a[k][j]/a[k][k];
    }
    for(i=k+1; i < N; ++i){
      //第i行について第k列を0にする
      b[i]=b[i]-b[k]*a[i][k];
      for(j=N-1; j >= k; --j){
	a[i][j]=a[i][j]-a[k][j]*a[i][k];
      }
    }
    //行列の出力
    printf("k:%d\n",k);
    print();
  }

  //後退代入
  for(j=N-1; j > 0; --j){
    for(i=j-1; i >= 0; --i){
      b[i] = b[i] - b[j]*a[i][j];
      a[i][j] = 0;
    }
  }
  //行列の出力
  printf("k:%d\n",k);
  print();
}

//配列a,bを行列とベクトル風に表示
void print()
{
  int i,j;
  for(i=0; i < N; ++i){
    for(j=0; j < N; ++j){
      printf("%f\t", a[i][j]);
    }
    printf("%f\n",b[i]);
  }
}
