#include <stdio.h>
#include <math.h>

#define N 3

double inner(double*, double*, int);

int main()
{
  int i,j,k;
  double err=1.0,eps=1.0e-4;
  double A[N][N]={{4,1,1},{2,6,1},{1,2,5}};
  double C[N][N];
  double b[N]={4,-8,7};
  double x[N]={1.0,1.0,1.0};
  double y[N]={0,0,0};
  double d[N]={0,0,0};
  
  //ヤコビ法の準備
  for(i=0; i<N; ++i){
    b[i]=b[i]/A[i][i];
    for(j=0; j<N; ++j){
      C[i][j]=0;
      if( i != j ){
	C[i][j]=A[i][j]/A[i][i];
      }
    }
  }

  //ヤコビ法の処理
  while(err > eps){
    for(i=0; i<N; ++i){
      y[i]=b[i];
      for(j=0; j<N; ++j){
	y[i]=y[i]-C[i][j]*x[j];
      }
    }

    for(j=0; j<N; ++j){
      d[j]=y[j]-x[j];
      x[j]=y[j];
      printf("%f ",x[j]);
    }
    printf("%.10f\n",err);
    err=sqrt(inner(d,d,N));
  }
}

double inner(double u[], double v[], int n)
{
  int k;
  double s=0;

  for(k=0; k<N; ++k){
    s+=u[k]*v[k];
  }
  return(s);
}
